define GLIMMERSTONE_VNUM 50926
define GLIMMERSTONE_COUNT 10
define PROB_GEM 10
define COST_GEM_YANG 5000
define MAX_GEM 999999

quest gem_system begin
	state start begin
		when 20504.chat."Bourses aux Gayas" begin
			setskin(NOWINDOW)
			game.open_gem_market()
		end

		when 20503.chat."Marchand de Gayas" begin
			say_title("Marchand de Gayas")
			say("Vous voulez vous faire de la monnaie de Gaya ?")
			say(string.format("Donner moi 10 gemmes prcieuse.", GLIMMERSTONE_COUNT))
		end

		when 20503.take with item.get_vnum() == GLIMMERSTONE_VNUM begin
			say_title("Marchand de Gayas")
			say("Il me faudras 10 gemmes prcieuse avec vos pierres d'esprit.")
			say("Toutes tentatives cotera 5000 Yang")
			say("Ma probiliter de russite est trs bas.. Attention !")
			if select("Oui", "Non") == 1 then
				if pc.get_gold() < COST_GEM_YANG then
					return say("Cela vous cotera 5000 Yang.")
				end

				if pc.get_gem() >= (MAX_GEM - 3) then
					return say("Vous avez trop de Gaya sur vous.")
				end

				if pc.count_item(GLIMMERSTONE_VNUM) < GLIMMERSTONE_COUNT then
					return say(string.format("Vous n'avez plus de gemmes prcieuse.", GLIMMERSTONE_COUNT))
				end

				local has_stone = false
				for stone = 28000, 28345 do -- all +0 to +3 stones
					if pc.count_item(stone) > 0 then
						has_stone = true
						break
					end
				end

				if not has_stone then
					return say("Vous n'avez plus de pierre d'esprit.")
				end

				game.open_gem()
			else return end
		end
	end
end
