quest growth_pet_system begin
	state start begin
		function get_pet_info(itemVnum)
			pet_info_map = {
				[55701] = {34041, " - "..mob_name(34041).." ", 0},
				[55702] = {34045, " - "..mob_name(34045).." ", 0},
				[55703] = {34049, " - "..mob_name(34049).." ", 0},
				[55704] = {34053, " - "..mob_name(34053).." ", 0},
				[55705] = {34036, " - "..mob_name(34036).." ", 0},
				[55706] = {34064, " - "..mob_name(34064).." ", 0},
				[55707] = {34073, " - "..mob_name(34073).." ", 0},
				[55708] = {34075, " - "..mob_name(34075).." ", 0},
				[55709] = {34080, " - "..mob_name(34080).." ", 0},
				[55710] = {34082, " - "..mob_name(34082).." ", 0},
				[55711] = {34047, " - "..mob_name(34082).." ", 0},
			}

			itemVnum = tonumber(itemVnum)
			return pet_info_map[itemVnum]
		end

		when
			55701.use or
			55702.use or
			55703.use or
			55704.use or
			55705.use or
			55706.use or
			55707.use or
			55708.use or
			55709.use or
			55710.use or
			55711.use
		begin
			local pet_info = growth_pet_system.get_pet_info(item.get_vnum())
			if nil != pet_info then
				local mobVnum = pet_info[1]
				local petName = pet_info[2]

				if true == growth_pet.is_summon(mobVnum) then
					growth_pet.unsummon(mobVnum)
				else
					if growth_pet.count_summoned() < 1 then
						growth_pet.summon(mobVnum, petName, false)
					else
						syschat("Vous avez dj appel votre familier.")
					end
				end
			end
		end
	end
end
