#!/bin/sh
#### @martysama0134 start scripts ####
v_base=$PWD
v_mt2f=$v_base
v_bakf=$v_base/save
v_dbf=$v_bakf/database
v_fsf=$v_bakf/serverfiles
v_foldername=files
v_localename=newcibn
v_bin=python2.7

fecho () { echo -e "\033[35m$1\033[0m"; }
_fecho () { echo -e "\033[4;35m$1\033[0m"; }
f_echo () { echo -e "\033[1;35m$1\033[0m"; }
becho () { echo -e "\033[34m$1\033[0m"; }
yecho () { echo -e "\033[33m$1\033[0m"; }
_yecho () { echo -e "\033[4;33m$1\033[0m"; }
y_echo () { echo -e "\033[1;33m$1\033[0m"; }
gecho () { echo -e "\033[32m$1\033[0m"; }
recho () { echo -e "\033[31m$1\033[0m"; }
_recho () { echo -e "\033[4;31m$1\033[0m"; }
r_echo () { echo -e "\033[1;31m$1\033[0m"; }
cecho () { echo -e "\033[36m$1\033[0m"; }
ruecho () { echo -e "\033[1;4;33;41m$1\033[0m"; }
bnecho () {  echo -e "\033[1;4;30;47m$1\033[0m"; }
rnecho () {  echo -e "\033[1;4;30;41m$1\033[0m"; }
abio () { echo -e "\033[31m$1\033[32m$1\033[33m$1\033[34m$1\033[35m$1\033[36m$1\033[37m$1\033[0m"; }

r_echo "---------------------------------"
r_echo " M2KSF - Panel d'Administration"
r_echo "---------------------------------"
gecho "---------------------------------"
gecho "ѡѡ֮һ:"
gecho "---------------------------------"
recho "[1]   - 
[2]   - رշ
[3]   - ־
[4]   - ݿ
[5]   - ļ
[666] - 
[777] - ±quest
[888] - Game Symlink
[999] - Recherche
[0]   - ˳"

if [ -z $1 ]; then
	read phase
else
	phase=$1
fi

case  $phase in
1|start)
	cd $v_mt2f
	$v_bin start.py
	cd $v_base
	cecho "ѳɹ"
;;
1i|starti)
	cd $v_mt2f
	$v_bin start.py --prompt
	cd $v_base
	cecho "ѳɹ"
;;
1a|startall)
	cd $v_mt2f
	sh daemon.sh &
	cd $v_base
	cecho "ѳɹ"
;;
2|stop|close)
	cd $v_mt2f
	$v_bin stop.py
	cd $v_base
	cecho "ѳɹر"
;;
2i|stopi|closei)
	cd $v_mt2f
	$v_bin stop.py --prompt
	cd $v_base
	cecho "ѳɹر"
;;
2a|stopall|closeall)
	ps afx | grep 'sh daemon.sh' | grep -v grep | awk '{print $1}' | xargs kill -9
	cd $v_mt2f
	$v_bin stop.py
	cd $v_base
	cecho "ѳɹر"
;;
3|clean|clear)
	cd $v_mt2f
	$v_bin clear.py
	cd $v_base
	cecho "ѳɹɾ־"
;;
33|cleanall|clearall)
	cd $v_mt2f
	$v_bin clear.py
	cd $v_base
	make -C $v_dbf clean
	make -C $v_fsf clean
	cecho "ѳɹɾ־"
;;
4|bak1|db|db_backup)
	make -C $v_dbf dump
	cecho "ѳɹݿ"
;;
5|bak2|fs|fs_backup)
	make -C $v_fsf dump
	cecho "ѳɹļ"
;;
666|gen)
	cd $v_mt2f
	$v_bin gen.py
	cd $v_base
	cecho "ѳɹ"
;;
777|quest)
	cd $v_mt2f/$v_foldername/share/locale/$v_localename/quest
	chmod u+x qc
	$v_bin pre_qc.py -ac
	cd $v_base
	cecho "ѳɹ"
;;
888|symlink)
	cd $v_mt2f/$v_foldername/share/bin
	rm -f game db
	ln -s /home/m2_sources/Server/game/game_symlink game
	ln -s /home/m2_sources/Server/db/db_symlink db
	cecho "Symlinkѳɹ"
;;
999|search)
	find $v_base -name "CONFIG" -print -exec cat {} \; | grep -e PORT -e HOSTNAME
;;
0|quit)
	abio ".:|:."
;;
*)
	cecho "$phase commande introuvable"
esac



