quest sash_mission begin
	state start begin
		when login or levelup with pc.get_level() >= 40 begin
			set_state("information")
		end
	end

	state information begin
		when enter begin
			pc.setqf("time_to_wait", 0)
			pc.setqf("collect_count", 0)
		end

		when letter begin
			local v = find_npc_by_vnum(60003)
			if v != 0 then
				target.vid("theowahdan", v, "Theowahdan")
			end
			
			send_letter("Une toffe spciale")
		end

		when button or info begin
			say_title(mob_name(60003))
			say("")
			say("Theowahdan vous cherche. Allez lui rendre visite")
			say("il a quelque chose vous dire.")
			say("")
		end

		when theowahdan.target.click or 60003.chat."Augmenter votre pouvoir" begin
			target.delete("theowahdan")

			say_title(mob_name(60003))
			say("")
			say("Ah, vous tes l ! J'ai dcouvert quelque chose.")
			say("Un nouvel quipement nomm l'tole.")
			say("")
			say("Les toles ont deux options :")
			say("Combiner et absorber.")
			say("")
			say("Combiner deux toles du mme type")
			say("vous donnera une nouvelle tole d'un")
			say("type plus rare et plus puissant.")
			say("")
			wait()
			say_title(mob_name(60003))
			say("")
			say("Dans l'absorption, l'tole prendra les bonus")
			say("d'une arme ou d'une armure de votre choix.")
			say("Vous possderez ces bonus de faon permanente")
			say("mais faites attention car votre arme ou ")
			say("armure sera dtruite dfinitivement..")
			say("")
			say("Pour crer votre premire tole.")
			say("Il vous faudra x40 "..item_name(80019)..".")
			say("")
			say("Le "..mob_name(20355).." vous attend.")
			say("Donnez lui le matriel ncessaire.")
			say("")
			set_state("go_to_disciple")
		end
	end

	state go_to_disciple begin
		when letter begin
			local v = find_npc_by_vnum(20355)
			if v != 0 then
				target.vid("captain", v, "Captain")
			end

			send_letter("Augmenter votre pouvoir")
		end

		when button or info begin
			say_title("Augmenter votre pouvoir")
			say("")
			say("Trouvez le "..mob_name(20355).." et donnez lui le matriel.")
			say("")
		end

		when captain.target.click or 20355.chat."Augmenter votre pouvoir" begin
			target.delete("captain")

			say_title(mob_name(20355))
			say("")
			say("Flicitations ! "..mob_name(60003).." m'a dit")
			say("que vous viendrez me voir. On a dcouvert rcemment que les")
			say("monstres sont devenus plus forts ces temps-ci.")
			say("")
			say("Grce  ces toles, votre pouvoir augmentera")
			say("et vous aurez la force de les combattre !")
			say("")
			say("Je peux crer votre tissu mais ce n'est pas si facile.")
			say("")
			say("Donnez moi trois heures, et je vous donnerai ce dont")
			say("vous avez besoin.")
			say("")
			wait()
			say_title(mob_name(20355))
			say("")
			say("Dans trois heures votre tissu sera prt.")
			say("Je vous la donnerai !")
			say("")
			say("C'est promis !")
			say("")
			say("Venez me revoir  l'heure !")
			say("")
			local agree = select("Oui", "Non")
			if agree == 1 then
				pc.setqf("time_to_wait", 60 * 3 + pc.get_playtime())
				set_state("time_to_wait")
			end
		end
	end
	
	state time_to_wait begin
		when letter begin
			local v = find_npc_by_vnum(20355)
			if v != 0 then
				target.vid("captain", v, "Captain")
			end
			
			send_letter("Augmenter votre pouvoir")
		end
		
		when button or info begin
			say_title("Augmenter votre pouvoir")
			say("")
			say("Trouvez le "..mob_name(20355)..", il vous donnera le matriel.")
			say("")
			if pc.getqf("time_to_wait") > pc.get_playtime() then
				local time_to_wait = pc.getqf("time_to_wait") - pc.get_playtime()
				say("Temps restant: "..time_to_wait.." minutes.")
				say("")
			end
		end

		when captain.target.click or 20355.chat."Augmenter votre pouvoir" begin
			target.delete("captain")

			say_title(mob_name(20355))
			say("")
			if pc.getqf("time_to_wait") > pc.get_playtime() then
				local time_to_wait = pc.getqf("time_to_wait") - pc.get_playtime()
				say("Ce n'est pas encore termin.")
				say("Veuillez patienter.")
				say("")
				say("Temps restant: "..time_to_wait.." minutes.")
				say("")
			else
				pc.setqf("time_to_wait", 0)
				say("Comme promis, voici votre tissu.")
				say("")
				if pc.getqf("collect_count") >= 39 then
					pc.setqf("collect_count", pc.getqf("collect_count") + 1)
					set_state("__complete")
				else
					pc.setqf("collect_count", pc.getqf("collect_count") + 1)
					set_state("go_to_disciple")
				end

				pc.give_item2(80019, 1)
			end
		end
	end
	
	state __complete begin
		when enter begin
			pc.delqf("time_to_wait")
			pc.delqf("collect_count")
		end

		when letter begin
			local v = find_npc_by_vnum(60003)
			if v != 0 then
				target.vid("theowahdan_reward", v, "Theowahdan")
			end

			send_letter("Une toffe spciale")
		end

		when button or info begin
			say_title(mob_name(60003))
			say("")
			say("Theowahdan veut crer une tole pour vous.")
			say("Allez donc lui rendre visite.")
			say("")
		end

		when theowahdan_reward.target.click or 60003.chat."Augmenter votre pouvoir" begin
			target.delete("theowahdan_reward")

			say_title(mob_name(60003))
			say("")
			say("Ah, vous tes l ! "..mob_name(20355).." m'a dit que")
			say("vous possdiez le matriel ncessaire.")
			say("")
			say("Laissez moi voir...")
			say("")
			wait()
			say_title(mob_name(60003))
			say("")
			if pc.count_item(80019) < 40 then
				say("Pardon ? Vous n'avez pas le matriel")
				say("ncessaire!")
				say("")
				say("Retournez voir le capitaine !")
				say("")
				set_state("go_to_disciple")
			else
				pc.remove_item(80019, 40)
				pc.give_item2_select(85005, 1)
				item.set_socket(1, 1)
				say("Parfait vous avez le tout.")
				say("")
				say_reward("Vous avez reu "..item_name(85005)..".")
				say("")
				say("Pour rpter la mission il suffit de venir me voir.")
				say("")
				set_state("information")
			end
		end
	end
end